#include "cpldbob.h"

#define DLLEXPORT extern "C" __declspec(dllexport)

static REALTIME _oldtime;
static bool _inittime;



DLLEXPORT IDSIMMODEL *createdsimmodel(CHAR* device, ILICENCESERVER *ils) 
{
	ils->authorize(0x88888888, 0x69);
	return new CCPLDBob();
}

DLLEXPORT void deletedsimmodel(IDSIMMODEL* model)
{
	delete (CCPLDBob*)model;	
}

DLLEXPORT IACTIVEMODEL *createactivemodel(CHAR *device, ILICENCESERVER *ils)
{
	ils->authorize(0);
	return new CCPLDBob();
}

DLLEXPORT VOID  deleteactivemodel(IACTIVEMODEL *model)
{
	delete (CCPLDBob*)model;
}

CCPLDBob::CCPLDBob()
{
	HCNT = 0;
	VCNT = 0;
	INTCNT = 0;
	

	vWRBUF = SLO;
	_vOEBUF = SHI;
	vATTR = SLO;

	ATTRVAL = 0;
	VIDVAL = 0;
	ATTRLAT = 0;
	VIDLAT = 0;

	_vINT = SHI;

	
	_vTRD = SHI;
	_vTWR = SHI;

	_vROM = SHI;
	_vRAM = SHI;
	//_vVRAM = SHI;
	
	vCTIME = SHI;
	vVTIME = SLO;
	
	cvCTIME = FLT;
	cvVTIME = FLT;
	//_cvVCS = FLT;
	_cvTRD = FLT;
	_cvTWR = FLT;
	//_cvVRAM = FLT;
	_cvIORD_FE = FLT;

	_inittime = false;

	FLCNT = 0;
	startINT = false;

	lock48k = false;
	selALTSCR = false;
	selROM1 = false;
	numRAMB = 0;

	//flog = fopen("framelog.txt", "wb");
}

CCPLDBob::~CCPLDBob()
{
	/*if (flog != NULL)
	{
		fclose(flog);
	}*/
}

int CCPLDBob::isdigital(CHAR *pinname)
{
	return 1;
}

void CCPLDBob::setup(IINSTANCE *inst, IDSIMCKT *dsim)
{	
	instance = inst;
	ckt = dsim;

	char pname[127] = { 0 };

	for (size_t i = 0; i < 80; i++)
	{
		sprintf(pname, "IO%d, io%d", i, i);
		
		iopins[i] = instance->getdsimpin(pname, true);
		iopins[i]->setstate(SLO);
		
	}
	
	for (size_t i = 0; i < 20; i++)
	{
		sprintf(pname, "DB%d, db%d", i, i);

		dbpins[i] = instance->getdsimpin(pname, true);
		dbpins[i]->setstate(STATE::SLO);
	}

	_inittime = false;


	iopins[8]->setstate(STATE::FLT);
	iopins[A0]->setstate(STATE::FLT);
	iopins[A1]->setstate(STATE::FLT);
	iopins[A2]->setstate(STATE::FLT);
	iopins[A3]->setstate(STATE::FLT);
	iopins[A4]->setstate(STATE::FLT);
	iopins[A5]->setstate(STATE::FLT);
	iopins[A6]->setstate(STATE::FLT);
	iopins[A7]->setstate(STATE::FLT);
	iopins[A8]->setstate(STATE::FLT);
	iopins[A9]->setstate(STATE::FLT);
	iopins[A10]->setstate(STATE::FLT);
	iopins[A11]->setstate(STATE::FLT);
	iopins[A12]->setstate(STATE::FLT);
	iopins[A13]->setstate(STATE::FLT);
	iopins[A14]->setstate(STATE::FLT);
	iopins[A15]->setstate(STATE::FLT);

	iopins[TD0]->setstate(STATE::FLT);
	iopins[TD1]->setstate(STATE::FLT);
	iopins[TD2]->setstate(STATE::FLT);
	iopins[TD3]->setstate(STATE::FLT);
	iopins[TD4]->setstate(STATE::FLT);
	iopins[TD5]->setstate(STATE::FLT);
	iopins[TD6]->setstate(STATE::FLT);
	iopins[TD7]->setstate(STATE::FLT);

	iopins[TA0]->setstate(STATE::FLT);
	iopins[TA1]->setstate(STATE::FLT);
	iopins[TA2]->setstate(STATE::FLT);
	iopins[TA3]->setstate(STATE::FLT);
	iopins[TA4]->setstate(STATE::FLT);
	iopins[TA5]->setstate(STATE::FLT);
	iopins[TA6]->setstate(STATE::FLT);
	iopins[TA7]->setstate(STATE::FLT);
	iopins[TA8]->setstate(STATE::FLT);
	iopins[TA9]->setstate(STATE::FLT);
	iopins[TA10]->setstate(STATE::FLT);
	iopins[TA11]->setstate(STATE::FLT);
	iopins[TA12]->setstate(STATE::FLT);
	iopins[TA13]->setstate(STATE::FLT);
	iopins[TA14]->setstate(STATE::FLT);
	iopins[TA15]->setstate(STATE::FLT);
	iopins[TA16]->setstate(STATE::FLT);

	iopins[ROMA14]->setstate(STATE::FLT); cvROMA14 = SLO;

	iopins[_M1]->setstate(STATE::FLT);
	iopins[_MREQ]->setstate(STATE::FLT);
	iopins[_IORQ]->setstate(STATE::FLT);
	iopins[_RD]->setstate(STATE::FLT);
	iopins[_WR]->setstate(STATE::FLT);
	iopins[_RFSH]->setstate(STATE::FLT);
	iopins[_RESET]->setstate(STATE::FLT);

	iopins[D0]->setstate(STATE::FLT);
	iopins[D1]->setstate(STATE::FLT);
	iopins[D2]->setstate(STATE::FLT);
	iopins[D3]->setstate(STATE::FLT);
	iopins[D4]->setstate(STATE::FLT);
	iopins[D5]->setstate(STATE::FLT);

		
	iopins[_INT]->setstate(STATE::FLT);
	iopins[_IORD_FE]->setstate(STATE::FLT);
	iopins[69]->setstate(STATE::FLT);

		
}

void CCPLDBob::runctrl(RUNMODES mode)
{
	//skip
}

void CCPLDBob::actuate(REALTIME time, ACTIVESTATE newstate)
{
	//skip
}

BOOL CCPLDBob::indicate(REALTIME time, ACTIVEDATA *data)
{
	//skip
	return TRUE;
}

void CCPLDBob::simulate(ABSTIME time, DSIMMODES mode)
{
	static STATE stRD(FLT);
	static STATE stWR(FLT);
	static STATE stM1(FLT);
	static STATE stMREQ(FLT);
	static STATE stRFSH(FLT);
	static STATE stIORQ(FLT);
	static STATE stA0(FLT);
	static STATE stA1(FLT);
	static STATE stA14(FLT);
	static STATE stA15(FLT);
	static STATE stCLK7(FLT);
	
	static bool startLine(false);
	static bool startFrame(false);
	
	stRD = iopins[_RD]->istate();
	stWR = iopins[_WR]->istate();
	stM1 = iopins[_M1]->istate();
	stMREQ = iopins[_MREQ]->istate();
	stRFSH = iopins[_RFSH]->istate();
	stIORQ = iopins[_IORQ]->istate();
	stCLK7 = iopins[CLK7]->istate();

	stA0 = iopins[A0]->istate();
	stA1 = iopins[A1]->istate();
	stA14 = iopins[A14]->istate();
	stA15 = iopins[A15]->istate();
	
	//--
	bool isMemAcc = (stRFSH == SHI && stMREQ == SLO);	
	bool isIOAcc = (stM1 == SHI && stIORQ == SLO);
	bool isRamAcc = (isMemAcc && !(stA15 == SLO && stA14 == SLO) /*&& (stWR == SLO || stRD == SLO)*/);
	
	_vROM = (isMemAcc && stA14 == SLO && stA15 == SLO) ? SLO : SHI;	
				
	//_IOWR_FE
	if (stA0 == SLO && stWR == SLO && isIOAcc)
	{
		vBRD[0] = iopins[D0]->istate();
		vBRD[1] = iopins[D1]->istate();
		vBRD[2] = iopins[D2]->istate();
	}
	
	//_IOWR_FE
	_vIORD_FE = (stA0 == SLO && stRD == SLO && isIOAcc) ? SLO : SHI;
	
	//128k  0x7FFD	
	if (stA0 == SHI && stA1 == SLO && stA15 == SLO && isIOAcc && !lock48k)
	{		
		numRAMB = 0;
		numRAMB |= (iopins[D0]->istate() == SLO) ? 0 : 1;
		numRAMB |= (iopins[D1]->istate() == SLO) ? 0 : 2;
		numRAMB |= (iopins[D2]->istate() == SLO) ? 0 : 4;
			
		selALTSCR = (iopins[D3]->istate() == SHI);
		selROM1 = (iopins[D4]->istate() == SHI);
		lock48k = (iopins[D5]->istate() == SHI);		
	}

	if (_vROM == SLO)
	{
		//vROMA14 = SLO;
		//AssociateIO(ROMA14, time);
		iopins[ROMA14]->setstate(0, 0, selROM1 ? SHI : SLO);
	}
		
	//_INT	
	if (vVSync == SHI && !startINT)
	{
		startINT = true;

	}

	if (startINT)
	{
		if (vH0 == SLO && VCNT == 1 && HCNT<64) _vINT = SLO;
	}

	if (_vINT == SLO && HCNT == 64)
	{
		_vINT = SHI;
		startINT = false;
	}

	if (stM1 == SLO && stIORQ == SLO)
	{
		startINT = false;
		_vINT = SHI;
	}
		
	_vOEBUF = (isRamAcc && stRD == SLO) ? SLO : SHI;

	if (vCTIME == SHI)
	{		
		_vRAM = SHI;
		_vTRD = SHI;
		_vTWR = SHI;
		if (stM1 == SLO) FltTA();
		
		if (_vROM == SHI)
		{
			int inaddr = ReadINA();// -0x4000;
			int psw = (inaddr & 0xC000) >> 14;

			switch (psw)
			{								
				case 1:
					inaddr = inaddr - 0x4000;
				break;
				
				case 2:
					inaddr = inaddr & 0x3FFF | 0x10000;
				break;
				
				case 3:
					if (numRAMB == 0) inaddr = inaddr & 0x3FFF | 0x8000;
					if (numRAMB == 1) inaddr = inaddr & 0x3FFF | 0xC000;
					if (numRAMB == 2) inaddr = inaddr & 0x3FFF | 0x10000;
					if (numRAMB == 3) inaddr = inaddr & 0x3FFF | 0x14000;
					if (numRAMB == 4) inaddr = inaddr & 0x3FFF | 0x18000;
					if (numRAMB == 5) inaddr = inaddr & 0x3FFF;
					if (numRAMB == 6) inaddr = inaddr & 0x3FFF | 0x1C000;
					if (numRAMB == 7) inaddr = inaddr & 0x3FFF | 0x4000;
				break;
			}

			SetTA(inaddr);
		}
		else
		{
			FltTA();
		}

		if ( isRamAcc && !(vVE == SHI || vVR == SHI))
		{
			_vRAM = SLO;
			_vTRD = stRD;
			_vTWR = stWR;

			
			
			/*if (inaddr & 0xC000)
			{
				vVRAMA14 = (numRAMB == 7) ? SHI : SLO;
			}*/
			
			
		}

		if ( isRamAcc && (vVE == SHI || vVR == SHI))
		{		
			_vRAM = (stRD == SLO || stWR == SLO) ? SLO : SHI;
			_vTRD = stRD;
			_vTWR = stWR;

			

			/*if (inaddr & 0xC000)
			{
				vVRAMA14 = (numRAMB == 7) ? SHI : SLO;
			}*/

			
		}

		if ( !isRamAcc && (vVE == SHI || vVR == SHI))
		{			
			_vRAM = SHI;
			_vTRD = SHI;
			_vTWR = SHI;
			//FltTA();						
		}

		AssociateTA_TADDR(time);
		AssociateIO(_OEBUF, time);
		AssociateIO(_RAM, time);
		AssociateIO(_ROM, time);
		AssociateIO(_TRD, time);
		AssociateIO(_TWR, time);		
	}


	/*{
		int inaddr = ReadINA();
		if (inaddr & 0xC000 && isMemAcc)
		{
			if (numRAMB == 0 || numRAMB == 2 || numRAMB == 4) vRAMA14 = SLO;
			if (numRAMB == 1 || numRAMB == 3 || numRAMB == 6) vRAMA14 = SHI;
		}

		if (inaddr & 0x8000 && isMemAcc)
		{
			vRAMA14 = SLO;
		}
	}*/


	AssociateIO(_RAM, time);	
	AssociateIO(_ROM, time);	
	AssociateIO(_IORD_FE, time);	
	AssociateIO(_OEBUF, time);
	AssociateIO(_INT, time);

	//--
	

	bool isCLK7NE = false;
	bool isCLK7PE = false;

	if (!(iopins[CLK7]->isposedge() || iopins[CLK7]->isnegedge())) return;	

	isCLK7PE = iopins[CLK7]->isposedge() == TRUE;
	isCLK7NE = iopins[CLK7]->isnegedge() == TRUE;

	//---

	if (isCLK7PE)
	{
		HCNT++;
		if (HCNT == 448) //    448
		{
			HCNT = 0;
			VCNT++;						
		}

		vH0 = (HCNT & 0x01) ? SHI : SLO;
		vH1 = (HCNT & 0x02) ? SHI : SLO;
		vH2 = (HCNT & 0x04) ? SHI : SLO;
		vH3 = (HCNT & 0x08) ? SHI : SLO;
		vH4 = (HCNT & 0x10) ? SHI : SLO;
		vH5 = (HCNT & 0x20) ? SHI : SLO;
		vH6 = (HCNT & 0x40) ? SHI : SLO;
		vH7 = (HCNT & 0x80) ? SHI : SLO;
		vH8 = (HCNT & 0x100) ? SHI : SLO;

		vCLKCPU = vINV(vH0);
		//vCLKCPU = vH0;

		if (VCNT == 312) //    312
		{
			VCNT = 0;
			INTCNT = 0;			
		}

		vHSync = (vH5 == SHI && vH6 == SHI && vH8 == SHI) ? SLO : SHI;
		vVSync = (VCNT>=0 && VCNT<4) ? SHI : SLO;
		
		int iHSync = vHSync == SLO ? 0 : 1;
		int iVSync = vVSync == SLO ? 0 : 1;
		vCSync = (iVSync ^ iHSync) == 0 ? SLO : SHI;
		vBLANK = (vCSync == SLO) ? SHI : vBLANK;
		vBLANK = (vH5 == SHI && vCSync == SHI) ? SLO : vBLANK;

		vVE = (vH8 == SLO && VCNT >= 64 && VCNT < 256) ? SHI : SLO;
		vVR = (HCNT>7 && HCNT<264) ? SHI : SLO;
		vVR = (VCNT >= 64 && VCNT < 256) ? vVR : SLO;		
		vVTIME = (vVE == SHI && vH1 == SHI) ? SHI : SLO;
		vCTIME = (vVTIME == SHI) ? SLO : SHI;
		vWRBUF = (vH0 == SHI && vH1 == SLO) ? SHI : SLO;

		if (cvVSync != vVSync && vVSync == SHI)
		{
			FLCNT++;
		}

				
		if (vVE == SHI)
		{									
			int vid_tstate = HCNT & 0x07;
			this->AssiciateDBD(vid_tstate, time);
			//this->AssiciateDBD(VIDLAT, time);
						
			if (vVTIME == SHI)
			{								
				//vATTR = (vid_tstate == 2 || vid_tstate == 3) ? SLO : SHI;				
				//CalcVA();

				if (vid_tstate == 2 || vid_tstate == 6)
				{										
					if (!isRamAcc) FltTA();
					_vRAM = SHI;
					_vTWR = SHI;
					_vTRD = SHI;										
				}
												
				
				AssociateTA_TADDR(time);
				AssociateIO(_RAM, time);
				AssociateIO(_TRD, time);
				AssociateIO(_TWR, time);
			}			
		}
		
		// 
		
		if (vBLANK == SHI) //        "   "
		{
			vRED = SLO;
			vGREEN = SLO;
			vBLUE = SLO;
			vBRIGHT = SLO;
		}
		else // 
		{
			// 
			if (vVR == SLO)
			{
				vRED = vBRD[1];
				vGREEN = vBRD[2];
				vBLUE = vBRD[0];
				vBRIGHT = SLO;
			}

			// 
			if (vVR == SHI)
			{
				int vid_tstate = HCNT & 0x07;

				if (vid_tstate == 0)
				{
					//TCharPlace lchar;

					ATTRLAT = ATTRVAL;
					VIDLAT = VIDVAL;

					//lchar.attr = ATTRLAT;
					//lchar.bmp = VIDLAT;

					//line.push_back(lchar);
					
				}
												
				bool px = VIDLAT & 0x80;
				bool flbit = (ATTRLAT & 0x80) && (FLCNT & 0x10);
				px = px ^ flbit;



				if (!px)
				{

					vBLUE = (ATTRLAT & 0x08) ? SHI : SLO;
					vRED = (ATTRLAT & 0x10) ? SHI : SLO;
					vGREEN = (ATTRLAT & 0x20) ? SHI : SLO;
					vBRIGHT = (ATTRLAT & 0x40) ? SHI : SLO;

				}
				else
				{
					vBLUE = (ATTRLAT & 0x01) ? SHI : SLO;
					vRED = (ATTRLAT & 0x02) ? SHI : SLO;
					vGREEN = (ATTRLAT & 0x04) ? SHI : SLO;
					vBRIGHT = (ATTRLAT & 0x40) ? SHI : SLO;
				}

				//      
				if (vRED == SLO && vGREEN == SLO && vBLUE == SLO) vBRIGHT = SLO;

				VIDLAT = (VIDLAT << 1);
			}			
		}

		

		AssociateIO(CLBLUE, time);
		AssociateIO(CLRED, time);
		AssociateIO(CLGREEN, time);
		AssociateIO(CLBRIGHT, time);

		AssociateIO(CLKCPU, time);
		AssociateIO(HSync, time);
		AssociateIO(VSync, time);
		AssociateIO(CSync, time);
		AssociateIO(WRBUF, time);		
		AssociateIO(_INT, time);

		AssociateDB(H0, time);
		AssociateDB(H1, time);
		AssociateDB(H2, time);
		AssociateDB(H8, time);
		AssociateDB(VE, time);
		AssociateDB(VR, time);
		AssociateDB(CTIME, time);
		AssociateDB(VTIME, time);
	}

	if (isCLK7NE)
	{
		if (vVE == SHI)
		{

			if (vVTIME == SHI)
			{
				int vid_tstate = HCNT & 0x07;

				if (vid_tstate == 3)
				{
					ATTRVAL = ReadTD();
					_vRAM = SHI;
					_vTRD = SHI;					
					//this->AssiciateDBD(ATTRVAL, time);
				}

				if (vid_tstate == 7)
				{
					VIDVAL = ReadTD();
					_vRAM = SHI;
					_vTRD = SHI;					
					//this->AssiciateDBD(VIDVAL, time);
				}

				if (vid_tstate == 2 || vid_tstate == 6)
				{					
					vATTR = (vid_tstate == 2 || vid_tstate == 3) ? SLO : SHI;					
					SetTA(CalcVA());
					_vRAM = SLO;
					_vTRD = SLO;
					_vTWR = SHI;
				}
								
				AssociateTA_TADDR(time);
				AssociateIO(_RAM, time);
				AssociateIO(_TRD, time);
				AssociateIO(_TWR, time);				
			}
		}
	}

	
	//AssociateVA_FLT(time);	
}


void CCPLDBob::callback(ABSTIME time, EVENTID eventid)
{
	//skip
}

void CCPLDBob::initialize(ICOMPONENT *cpt)
{	
	//skip
}

ISPICEMODEL* CCPLDBob::getspicemodel(CHAR *device)
{
	return NULL;
}

IDSIMMODEL* CCPLDBob::getdsimmodel(CHAR *device)
{
	return this;
}

void CCPLDBob::plot(ACTIVESTATE state)
{
	//skip
	//instance->log("CCPLDBob: plot");
}

void CCPLDBob::animate(INT element, ACTIVEDATA *newstate)
{
	//skip
}

BOOL CCPLDBob::actuate(WORD key, INT x, INT y, DWORD flags)
{
	//skip	
	return FALSE;
}


void __fastcall CCPLDBob::AssociateIO(int num, ABSTIME time)
{	
	switch (num)
	{
		case CLKCPU:
			if (cvCLKCPU != vCLKCPU) { iopins[num]->setstate(0, 0, vCLKCPU); cvCLKCPU = vCLKCPU; }
			break;

		case _INT:
			if (_cvINT != _vINT) { iopins[num]->setstate(0, 0, _vINT); _cvINT = _vINT; }
			break;

		case HSync:
			if (cvHSync != vHSync) { iopins[num]->setstate(0, 0, vHSync); cvHSync = vHSync; }
			break;

		case VSync:
			if (cvVSync != vVSync) { iopins[num]->setstate(0, 0, vVSync); cvVSync = vVSync; }
			break;

		case CSync: 
			if (cvCSync != vCSync) { iopins[num]->setstate(0, 0, vCSync); cvCSync = vCSync; }
		break;
		
		case WRBUF:
			if (cvWRBUF != vWRBUF) { iopins[num]->setstate(0, 0, vWRBUF); cvWRBUF = vWRBUF; }
		break;
		
		case _OEBUF:
			if (_cvOEBUF != _vOEBUF) { iopins[num]->setstate(0, 0, _vOEBUF); _cvOEBUF = _vOEBUF; }
		break;

		case _TRD:
			if (_cvTRD != _vTRD) { iopins[num]->setstate(0, 0, _vTRD); _cvTRD = _vTRD; }
		break;

		case _TWR:
			if (_cvTWR != _vTWR) { iopins[num]->setstate(0, 0, _vTWR); _cvTWR = _vTWR; }
		break;

		case _IORD_FE: iopins[num]->setstate(0, 0, _vIORD_FE); break;

		case _ROM:
			if (_cvROM != _vROM) { iopins[num]->setstate(0, 0, _vROM); _cvROM = _vROM; }
		break;

		case _RAM:
			if (_cvRAM != _vRAM) { iopins[num]->setstate(0, 0, _vRAM); _cvRAM = _vRAM; }
		break;
					
		case TA0: iopins[num]->setstate(0, 0, vTA[0]); break;
		case TA1: iopins[num]->setstate(0, 0, vTA[1]); break;
		case TA2: iopins[num]->setstate(0, 0, vTA[2]); break;
		case TA3: iopins[num]->setstate(0, 0, vTA[3]); break;
		case TA4: iopins[num]->setstate(0, 0, vTA[4]); break;
		case TA5: iopins[num]->setstate(0, 0, vTA[5]); break;
		case TA6: iopins[num]->setstate(0, 0, vTA[6]); break;
		case TA7: iopins[num]->setstate(0, 0, vTA[7]); break;
		case TA8: iopins[num]->setstate(0, 0, vTA[8]); break;
		case TA9: iopins[num]->setstate(0, 0, vTA[9]); break;
		case TA10: iopins[num]->setstate(0, 0, vTA[10]); break;
		case TA11: iopins[num]->setstate(0, 0, vTA[11]); break;
		case TA12: iopins[num]->setstate(0, 0, vTA[12]); break;
		case TA13: iopins[num]->setstate(0, 0, vTA[13]); break;
		case TA14: iopins[num]->setstate(0, 0, vTA[14]); break;
		case TA15: iopins[num]->setstate(0, 0, vTA[15]); break;
		case TA16: iopins[num]->setstate(0, 0, vTA[16]); break;

		case TD0: iopins[num]->setstate(0, 0, vTD[0]); break;
		case TD1: iopins[num]->setstate(0, 0, vTD[1]); break;
		case TD2: iopins[num]->setstate(0, 0, vTD[2]); break;
		case TD3: iopins[num]->setstate(0, 0, vTD[3]); break;
		case TD4: iopins[num]->setstate(0, 0, vTD[4]); break;
		case TD5: iopins[num]->setstate(0, 0, vTD[5]); break;
		case TD6: iopins[num]->setstate(0, 0, vTD[6]); break;
		case TD7: iopins[num]->setstate(0, 0, vTD[7]); break;

		case ROMA14:
			if (cvROMA14 != vROMA14) {iopins[num]->setstate(0, 0, vROMA14); cvROMA14 = vROMA14;}
		break;

		case CLRED: iopins[num]->setstate(0, 0, vRED); break;
		case CLGREEN:  iopins[num]->setstate(0, 0, vGREEN); break;
		case CLBLUE:  iopins[num]->setstate(0, 0, vBLUE); break;
		case CLBRIGHT:  iopins[num]->setstate(0, 0, vBRIGHT); break;
	}
}

void __fastcall CCPLDBob::AssociateDB(int num, ABSTIME time)
{	
	switch (num)
	{
		case H0:		dbpins[num]->setstate(0, 0, vH0); break;
		case H1:		dbpins[num]->setstate(0, 0, vH1); break;
		case H2:		dbpins[num]->setstate(0, 0, vH2); break;
		case H8:		dbpins[num]->setstate(0, 0, vH8); break;
		case VE:		dbpins[num]->setstate(0, 0, vVE); break;
		case VR:		dbpins[num]->setstate(0, 0, vVR); break;
		case CTIME:		dbpins[num]->setstate(0, 0, vCTIME); break;
		case VTIME:		dbpins[num]->setstate(0, 0, vVTIME); break;
		case ATTR:		dbpins[num]->setstate(0, 0, vATTR); break;
		case BLANK:		dbpins[num]->setstate(0, 0, vBLANK); break;
		case DBD0:      dbpins[num]->setstate(0, 0, vDBD[0]); break;
		case DBD1:		dbpins[num]->setstate(0, 0, vDBD[1]); break;
		case DBD2:		dbpins[num]->setstate(0, 0, vDBD[2]); break;
		case DBD3:		dbpins[num]->setstate(0, 0, vDBD[3]); break;
		case DBD4:		dbpins[num]->setstate(0, 0, vDBD[4]); break;
		case DBD5:		dbpins[num]->setstate(0, 0, vDBD[5]); break;
		case DBD6:		dbpins[num]->setstate(0, 0, vDBD[6]); break;
		case DBD7:		dbpins[num]->setstate(0, 0, vDBD[7]); break;
	}
}

void __fastcall CCPLDBob::AssiciateDBD(uint8_t dat, ABSTIME time)
{
	vDBD[0] = (dat & 0x01) ? SHI : SLO;
	vDBD[1] = (dat & 0x02) ? SHI : SLO;
	vDBD[2] = (dat & 0x04) ? SHI : SLO;
	vDBD[3] = (dat & 0x08) ? SHI : SLO;
	vDBD[4] = (dat & 0x10) ? SHI : SLO;
	vDBD[5] = (dat & 0x20) ? SHI : SLO;
	vDBD[6] = (dat & 0x40) ? SHI : SLO;
	vDBD[7] = (dat & 0x80) ? SHI : SLO;

	AssociateDB(DBD0, time);
	AssociateDB(DBD1, time);
	AssociateDB(DBD2, time);
	AssociateDB(DBD3, time);
	AssociateDB(DBD4, time);
	AssociateDB(DBD5, time);
	AssociateDB(DBD6, time);
	AssociateDB(DBD7, time);
}

void __fastcall CCPLDBob::AssociateTA_TADDR(ABSTIME time)
{
	int numout[] = { TA0, TA1, TA2, TA3, TA4, TA5, TA6, TA7,
		TA8, TA9, TA10, TA11, TA12, TA13, TA14, TA15, TA16, -1 };

	for (size_t i = 0; numout[i]>0; i++) AssociateIO(numout[i], time);
}

void __fastcall CCPLDBob::AssociateTA_FLT(ABSTIME time)
{
	int numout[] = { TA0, TA1, TA2, TA3, TA4, TA5, TA6, TA7,
		TA8, TA9, TA10, TA11, TA12, TA13, TA14, TA15, TA16, -1 };

	FltTA();

	for (size_t i = 0; numout[i]>0; i++)
	{		
		AssociateIO(numout[i], time);
	}
}

int __fastcall CCPLDBob::CalcVA(/*int inaddr*/)
{
	int vaddrval = 0;
	
	if (vVTIME == SHI)
	{		
		int xsym = HCNT / 8;
		int ylin = VCNT-64;

		
		if (vATTR == SLO) vaddrval = xsym | ((ylin>>3)<<5) | 0x1800; 
		else vaddrval = xsym | ((ylin & 0x07) << 3 | (ylin & 0x38) >> 3) << 5 | (ylin & 0xC0)<<5;

		vaddrval |= selALTSCR ? 0x4000 : 0;
		return vaddrval;
	
		/*vTA[14] = SLO;
		vTA[15] = SLO;
		vTA[16] = SLO;

		for (size_t i = 0; i < 14; i++)
		{
			vTA[i] = (vaddrval & 0x01) ? SHI : SLO;
			vaddrval = vaddrval >> 1;
		}		*/
	}
	
}

int __fastcall CCPLDBob::ReadINA()
{
	int oa(0);

	oa |= (iopins[A0]->istate() == SHI) ? 0x0001 : 0;
	oa |= (iopins[A1]->istate() == SHI) ? 0x0002 : 0;
	oa |= (iopins[A2]->istate() == SHI) ? 0x0004 : 0;
	oa |= (iopins[A3]->istate() == SHI) ? 0x0008 : 0;
	oa |= (iopins[A4]->istate() == SHI) ? 0x0010 : 0;
	oa |= (iopins[A5]->istate() == SHI) ? 0x0020 : 0;
	oa |= (iopins[A6]->istate() == SHI) ? 0x0040 : 0;
	oa |= (iopins[A7]->istate() == SHI) ? 0x0080 : 0;
	oa |= (iopins[A8]->istate() == SHI) ? 0x0100 : 0;
	oa |= (iopins[A9]->istate() == SHI) ? 0x0200 : 0;
	oa |= (iopins[A10]->istate() == SHI) ? 0x0400 : 0;
	oa |= (iopins[A11]->istate() == SHI) ? 0x0800 : 0;
	oa |= (iopins[A12]->istate() == SHI) ? 0x1000 : 0;
	oa |= (iopins[A13]->istate() == SHI) ? 0x2000 : 0;
	oa |= (iopins[A14]->istate() == SHI) ? 0x4000 : 0;
	oa |= (iopins[A15]->istate() == SHI) ? 0x8000 : 0;

	return oa;	
}

int __fastcall CCPLDBob::ReadTD()
{
	int od(0);

	od |= (iopins[TD0]->istate() == SHI) ? 0x01 : 0;
	od |= (iopins[TD1]->istate() == SHI) ? 0x02 : 0;
	od |= (iopins[TD2]->istate() == SHI) ? 0x04 : 0;
	od |= (iopins[TD3]->istate() == SHI) ? 0x08 : 0;
	od |= (iopins[TD4]->istate() == SHI) ? 0x10 : 0;
	od |= (iopins[TD5]->istate() == SHI) ? 0x20 : 0;
	od |= (iopins[TD6]->istate() == SHI) ? 0x40 : 0;
	od |= (iopins[TD7]->istate() == SHI) ? 0x80 : 0;

	return od;
}

int __fastcall CCPLDBob::ReadBRD()
{
	int ob(0);
	ob |= iopins[D0]->istate() == SHI ? 0x01 : 0;
	ob |= iopins[D1]->istate() == SHI ? 0x02 : 0;
	ob |= iopins[D2]->istate() == SHI ? 0x04 : 0;

	return ob;
}

void __fastcall CCPLDBob::SetTA(int addr)
{
	vTA[0] = (addr & 0x0001) ? SHI : SLO;
	vTA[1] = (addr & 0x0002) ? SHI : SLO;
	vTA[2] = (addr & 0x0004) ? SHI : SLO;
	vTA[3] = (addr & 0x0008) ? SHI : SLO;
	vTA[4] = (addr & 0x0010) ? SHI : SLO;
	vTA[5] = (addr & 0x0020) ? SHI : SLO;
	vTA[6] = (addr & 0x0040) ? SHI : SLO;
	vTA[7] = (addr & 0x0080) ? SHI : SLO;
	vTA[8] = (addr & 0x0100) ? SHI : SLO;
	vTA[9] = (addr & 0x0200) ? SHI : SLO;
	vTA[10] = (addr & 0x0400) ? SHI : SLO;
	vTA[11] = (addr & 0x0800) ? SHI : SLO;
	vTA[12] = (addr & 0x1000) ? SHI : SLO;
	vTA[13] = (addr & 0x2000) ? SHI : SLO;
	vTA[14] = (addr & 0x4000) ? SHI : SLO;
	vTA[15] = (addr & 0x8000) ? SHI : SLO;
	vTA[16] = (addr & 0x10000) ? SHI : SLO;
}

void __fastcall CCPLDBob::FltTA()
{
	for (size_t i = 0; i < 17; i++) vTA[i] = FLT;	
}




