#pragma once

#include <windows.h>
#include "vsm.hpp"

#include <stdio.h>
#include <stdint.h>

#include <vector>

struct TCharPlace
{
	uint8_t attr;
	uint8_t bmp;
};

#define TD0 0
#define TD1 1
#define TD2 2
#define TD3 3
#define TD4 4
#define TD5 5
#define TD6 6
#define TD7 7

#define CLK7 8

#define A0 9
#define A1 10
#define A2 11
#define A3 12
#define A4 13
#define A5 14
#define A6 15
#define A7 16
#define A8 17
#define A9 18
#define A10 19
#define A11 20
#define A12 21
#define A13 22
#define A14 23
#define A15 24

#define _M1 25
#define _MREQ 26
#define _IORQ 27
#define _RD 28
#define _WR 29
#define _RFSH 30
#define _RESET 31
#define D0 32
#define D1 33
#define D2 34
#define D3 35
#define D4 36
#define D5 37

#define TA0 40
#define TA1 41
#define TA2 42
#define TA3 43
#define TA4 44
#define TA5 45
#define TA6 46
#define TA7 47
#define TA8 48
#define TA9 49
#define TA10 50
#define TA11 51
#define TA12 52
#define TA13 53
#define TA14 66
#define TA15 68
#define TA16 72

#define ROMA14 73

#define _TRD 55
#define _TWR 56

#define CLKCPU 57
#define _INT 58

#define CLRED 59
#define CLGREEN 60
#define CLBLUE 61
#define CLBRIGHT 62

#define VSync 63
#define HSync 64
#define CSync 65

#define _IORD_FE 67

#define WRBUF 70
#define _OEBUF 71

#define _RAM 78
#define _ROM 79

#define H8 0
#define VE 1
#define VR 2

#define H0 3
#define H1 4
#define H2 5

#define CTIME 6
#define VTIME 7
#define ATTR 8
#define BLANK 9

#define DBD0 10
#define DBD1 11
#define DBD2 12
#define DBD3 13
#define DBD4 14
#define DBD5 15
#define DBD6 16
#define DBD7 17

#define vINV(s)  (s == SHI) ? SLO : SHI;

class CCPLDBob : public IACTIVEMODEL, public IDSIMMODEL
{
public:
	CCPLDBob();
	~CCPLDBob();

	int isdigital(CHAR *pinname);
	void setup(IINSTANCE *inst, IDSIMCKT *dsim);
	void runctrl(RUNMODES mode);
	void actuate(REALTIME time, ACTIVESTATE newstate);
	BOOL indicate(REALTIME time, ACTIVEDATA *data);
	void simulate(ABSTIME time, DSIMMODES mode);
	void callback(ABSTIME time, EVENTID eventid);
	void initialize(ICOMPONENT *cpt);
	ISPICEMODEL *getspicemodel(CHAR *device);
	IDSIMMODEL *getdsimmodel(CHAR *device);
	void plot(ACTIVESTATE state);
	void animate(INT element, ACTIVEDATA *newstate);
	BOOL actuate(WORD key, INT x, INT y, DWORD flags);

private:
	IINSTANCE *instance;
	IDSIMCKT *ckt;
	ICOMPONENT *component;

	IDSIMPIN* iopins[80];
	IDSIMPIN* dbpins[20];

private:
	//
	//FILE* flog;
	//std::vector<TCharPlace> line;
	//std::vector<std::vector<TCharPlace> > frame;

	//
	int HCNT, VCNT, FLCNT, PXCNT, INTCNT;	
	int ATTRVAL, VIDVAL;
	int ATTRLAT, VIDLAT;
	bool startINT;
	
	bool lock48k;
	bool selALTSCR;
	bool selROM1; //48k
	int  numRAMB;
	
	//io
	STATE vCLKCPU, cvCLKCPU;
	STATE vHSync, cvHSync;
	STATE vVSync, cvVSync;
	STATE vCSync, cvCSync;
	STATE vWRBUF, cvWRBUF;
	STATE vTA[17], cvTA[17];
	STATE vTD[8], cvTD[8];
	STATE vROMA14, cvROMA14;
	STATE vBRD[3];
	STATE _vTRD, _cvTRD;
	STATE _vTWR, _cvTWR;
	STATE vRED, cvRED;
	STATE vGREEN, cvGREEN;
	STATE vBLUE, cvBLUE;
	STATE vBRIGHT, cvBRIGHT;
	STATE _vROM, _cvROM;
	STATE _vRAM, _cvRAM;
	//STATE _vVRAM, _cvVRAM;
	STATE _vIORD_FE, _cvIORD_FE;
	STATE _vINT, _cvINT;
	STATE _vOEBUF, _cvOEBUF;

	//debug
	STATE vH0, cvH0; //Ha -   speccybob
	STATE vH1, cvH1;	
	STATE vH2, cvH2;
	STATE vH3, cvH3;
	STATE vH4, cvH4;
	STATE vH5, cvH5;
	STATE vH6, cvH6;
	STATE vH7, cvH7;
	STATE vH8, cvH8; //H7 -   speccybob
	STATE vVE, cvVE;
	STATE vVR, cvVR;
	STATE vCTIME, cvCTIME;
	STATE vVTIME, cvVTIME;
	STATE vATTR, cvATTR;
	STATE vDBD[8], cvDBD[8];
	STATE vBLANK, cvBLANK;

	void __fastcall AssociateIO(int num, ABSTIME time);
	void __fastcall AssociateDB(int num, ABSTIME time);
	void __fastcall AssiciateDBD(uint8_t dat, ABSTIME time);
	void __fastcall AssociateTA_TADDR(ABSTIME time);
	void __fastcall AssociateTA_FLT(ABSTIME time);
	int __fastcall CalcVA(/*int inaddr*/);
	int __fastcall ReadTD();
	int __fastcall ReadBRD();
	int __fastcall ReadINA();
	void __fastcall SetTA(int addr);
	void __fastcall FltTA();
};
